Linux "flock" Command Line Options and Examples
apply or remove an advisory lock on an open file

This utility manages flock(2) locks from within shell scripts or from the command line. The first and second of the above forms wrap the lock around the execution of a command, in a manner similar to su(1) or newgrp(1). They lock a specified file or directory, which is created (assuming appropriate permissions) if it does not already exist.


Usage:

flock [options] file|directory command [arguments]
    flock [options] file|directory -c command
    flock [options] number




Command Line Options:

-c
Pass a single command, without arguments, to the shell with -c.
flock -c ...
-E
The exit code used when the -n option is in use, and the conflicting lock exists, or the -w option is in use, and the timeoutis reached. The default value is 1.
flock -E ...
-F
Do not fork before executing command. Upon execution the flock process is replaced by command which continues to hold thelock. This option is incompatible with --close as there would otherwise be nothing left to hold the lock.
flock -F ...
-e
Obtain an exclusive lock, sometimes called a write lock. This is the default.
flock -e ...
-n
Fail rather than wait if the lock cannot be immediately acquired. See the -E option for the exit code used.
flock -n ...
-o
Close the file descriptor on which the lock is held before executing command. This is useful if command spawns a childprocess which should not be holding the lock.
flock -o ...
-s
Obtain a shared lock, sometimes called a read lock.
flock -s ...
-u
Drop a lock. This is usually not required, since a lock is automatically dropped when the file is closed. However, it may berequired in special cases, for example if the enclosed command group may have forked a background process which should not beholding the lock.
flock -u ...
-w
Fail if the lock cannot be acquired within seconds. Decimal fractional values are allowed. See the -E option for the exitcode used. The zero number of seconds is interpreted as --nonblock.
flock -w ...
--verbose
Report how long it took to acquire the lock, or why the lock could not be obtained.
flock --verbose ...
-V
Display version information and exit.
flock -V ...
-h
Display help text and exit.EXAMPLESshell1> flock /tmp -c catshell2> flock -w .007 /tmp -c echo; /bin/echo $?Set exclusive lock to directory /tmp and the second command will fail.shell1> flock -s /tmp -c catshell2> flock -s -w .007 /tmp -c echo; /bin/echo $?Set shared lock to directory /tmp and the second command will not fail. Notice that attempting to get exclusive lock withsecond command would fail.shell> flock -x local-lock-file echo 'a b c'Grab the exclusive lock "local-lock-file" before running echo with 'a b c'.(flock -n 9 || exit 1# ... commands executed under lock ...) 9>/var/lock/mylockfileThe form is convenient inside shell scripts. The mode used to open the file doesn't matter to flock; using > or >> allows thelockfile to be created if it does not already exist, however, write permission is required. Using < requires that the filealready exists but only read permission is required.[ "${FLOCKER}" != "$0" ] && exec env FLOCKER="$0" flock -en "$0" "$0" "$@" || :This is useful boilerplate code for shell scripts. Put it at the top of the shell script you want to lock and it'll automati‐cally lock itself on the first run. If the env var $FLOCKER is not set to the shell script that is being run, then executeflock and grab an exclusive non-blocking lock (using the script itself as the lock file) before re-execing itself with theright arguments. It also sets the FLOCKER env var to the right value so it doesn't run again.EXIT STATUSThe command uses sysexits.h return values for everything, except when using either of the options -n or -w which report a failure toacquire the lock with a return value given by the -E option, or 1 by default.When using the command variant, and executing the child worked, then the exit status is that of the child command.AUTHORH. Peter Anvin ⟨hpa@zytor.com⟩COPYRIGHTCopyright © 2003-2006 H. Peter Anvin.This is free software; see the source for copying conditions. There is NO warranty; not even for MERCHANTABILITY or FITNESS FOR APARTICULAR PURPOSE.
flock -h ...